@use "sass:map";
@use "../core/" as adm;

$name: 'adm-button';
$component-tokens: (
	#{$name}: (
		default: (

			// backgrounds
			background: #ccc,
            background-hover: #aaa,
            background-focus: adm.c-token($name, 'background'),
            background-active: adm.c-token($name, 'background'),

			// text
            text: #000,
            text-hover: adm.c-token($name, 'text'),
            text-focus: adm.c-token($name, 'text'),
            text-active: adm.c-token($name, 'text'),

			// borders
            border: none,
			border-hover: adm.c-token($name, 'border'),
			border-focus: adm.c-token($name, 'border'),
			border-active: adm.c-token($name, 'border'),

			// outline for focus
			outline-offset: 2px,
			outline: 2px solid #000,
			
			// misc
            padding-x: 20px,
            padding-y: 10px,
            radius: 4px,
			gap: 0.5rem,

			// size
            width: auto,
            height: auto,
            
			// typo
			font-family: inherit,
            font-weight: 400,
            font-size: inherit,
            line-height: inherit,

			text-decoration: none,
            text-decoration-hover: adm.c-token($name, 'text-decoration'),
            text-decoration-focus: adm.c-token($name, 'text-decoration-hover'),
            text-decoration-active: adm.c-token($name, 'text-decoration-hover'),
            underline-offset: 0.2em,  
		),
	),
) !default;

//@include adm.generate-component-tokens($component-tokens, '.adm-button');

// generate the button markup 
@mixin generate-component-markup() {
	:host {
		display: inline-flex;
		box-sizing: border-box;
	}

	.#{$name} {	
		position: relative;
		display: inline-flex;
		align-items: center;
		justify-content: center;
		text-decoration: none;
		box-sizing: border-box;
		cursor: pointer;

		background: adm.c-token($name, 'background');
		color: adm.c-token($name, 'text');
		border: adm.c-token($name, 'border');
		outline-offset: adm.c-token($name, 'outline-offset');

		padding-left: adm.c-token($name, 'padding-x');
		padding-right: adm.c-token($name, 'padding-x');
		padding-top: adm.c-token($name, 'padding-y');
		padding-bottom: adm.c-token($name, 'padding-y');

		height: adm.c-token($name, 'height');
		width: adm.c-token($name, 'width');
		border-radius: adm.c-token($name, 'radius');

		font-family: adm.c-token($name, 'font-family');
		font-weight: adm.c-token($name, 'font-weight');
		font-size: adm.c-token($name, 'font-size');
		line-height: adm.c-token($name, 'line-height');

		text-decoration: adm.c-token($name, 'text-decoration');
		text-underline-offset: adm.c-token($name, 'underline-offset');
		
		gap: adm.c-token($name, 'gap');
		
		&:hover {
			background: adm.c-token($name, 'background-hover');
			color: adm.c-token($name, 'text-hover');
			border: adm.c-token($name, 'border-hover');
			text-decoration: adm.c-token($name, 'text-decoration-hover');
		}
		&:focus-visible {
			background: adm.c-token($name, 'background-focus');
			color: adm.c-token($name, 'text-focus');
			border: adm.c-token($name, 'border-focus');
			outline: adm.c-token($name, 'outline');
			text-decoration: adm.c-token($name, 'text-decoration-focus');
		}
		&:active {
			background: adm.c-token($name, 'background-active');
			color: adm.c-token($name, 'text-active');
			border: adm.c-token($name, 'border-active');
			text-decoration: adm.c-token($name, 'text-decoration-active');
		}
		
	}

	:host([disabled]),
    [disabled] {
        opacity: 0.4;
        pointer-events: none;
    }

	// individual code
	@content;

}